namespace Avalonia.Media
{
    /// <summary>
    /// Describes how content is positioned horizontally in a container.
    /// </summary>
    public enum AlignmentX
    {
        /// <summary>
        /// The contents align themselves with the left of the container
        /// </summary>
        Left,

        /// <summary>
        /// The contents align themselves with the center of the container
        /// </summary>
        Center,

        /// <summary>
        /// The contents align themselves with the right of the container
        /// </summary>
        Right,
    }
}
